!---------------------------------------------------------------------------------------
! FLEXINVERT : mod_var 
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------

module mod_var

  implicit none

  ! path constants
  character(len=100) :: dirinvert,dirout
  character(len=20) :: logfile

  ! parameters
  real, parameter :: numscale=1.e12  ! numeric scaling factor
  real, parameter :: outheight=100.  ! height of first layer in flexpart
  real, parameter :: dx=1.           ! lon resolution
  real, parameter :: dy=1.           ! lat resolution
  integer, parameter :: logid=500
  real :: ineq
  integer :: nemsteps
  logical :: scaleflx

  ! variables
  integer :: nxgrid,nygrid,nbox,nvar
  integer :: nlon,nlat,ntime
  integer :: nineq
  integer, dimension(:,:), allocatable :: nbox_xy
  real, dimension(:), allocatable :: area_box
  real, dimension(:), allocatable :: lon,lat,time
  real, dimension(:,:,:), allocatable :: emisprior,emispost
  real, dimension(:,:), allocatable :: cova
  real, dimension(:), allocatable :: xb,x0,x
  integer, dimension(:,:), allocatable :: selmat
  real, dimension(:), allocatable :: ineqvec
  
end module mod_var

