!---------------------------------------------------------------------------------------
! FLEXINVERT : save
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Save outputs to file 
!---------------------------------------------------------------------------------------

subroutine save()

  use mod_var

  implicit none

  character(len=100) :: fileout,varname,varunit,comment
  character(len=20) :: dname1,dname2,dname3
  integer :: n,ierr

  ! posterior state vector on coarse grid (x)

  open(100,file=trim(dirinvert)//'constraint.txt',status='replace',action='write',iostat=ierr)
  do n=1,nemsteps*nbox
    write(100,*) x(n)*outheight/numscale
  end do
  close(100)

  ! gridded posterior fluxes

  emispost=emispost*outheight/numscale

  fileout='constraint.nc'
  varname='emis_post'
  varunit='kg/m2/s'
  dname1='longitude'
  dname2='latitude'
  dname3='time'
  comment='posterior emissions with inequality constraint'
  call write3Dncdf(fileout,varname,varunit,emispost,&
                   &nlon,nlat,ntime,lon,lat,time,&
                   &dname1,dname2,dname3,comment)  

end subroutine save

